package java_http;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.InvalidPropertiesFormatException;
import java.util.Properties;
import java.util.concurrent.locks.Lock;
import java.util.Vector;
import java.util.Map;
import java.util.HashMap;
import java.util.Iterator;

class dt_info{
	String str_svr;
	long time;
}
public class java_http {
	 
	 private String str_url;
	 private static String ENCODING = "gb2312";
	 private static String EXTRA  = "--";
	 private String BOUNDARY;
	 private static String CRLF = "\r\n";
	 private static String QUOTE = "\"";
	 private String FILE_NAME = "; filename=";
	 private String CONTENT_DISPOSITION = "Content-Disposition: form-data; name=";
	 private static String str_author="";
	 private static String str_query_svr="http://plugin.config.91yzm.com:8080/apisvrs.php?ver=20";
	 private static Vector<String> svr_addr=new Vector<String>();
	 private static Map<String,dt_info> id_addr=new HashMap<String,dt_info>();//Ӧŵķsvrַ
	 private static long preQueryTime=0;
	    
	 
	    private HttpURLConnection conn =null;
	    
	 public java_http(String remoteUrl){
		 str_url=remoteUrl;      
	 }
	 public static void SetAuthor(String author){
		 str_author=author;      
	 }
	 public void GetSvrAddr(){
		 long curTime=System.currentTimeMillis();

		 String data="";
		 //5Ӹ´·
		 if(curTime>preQueryTime+5*60*1000){
			 preQueryTime=curTime;
			 try{
				 data=SendGet(str_query_svr,"");
			 } catch(Exception e){
				 
			 }
		 }
		 if(data!=null && !data.isEmpty()){
			 //õķַ
			 Vector<String> vAddr=new Vector<String>();
			 int pre_pos=0;
			 while(true){
				 int pos = data.indexOf(";");
				 if(pos!=-1){
					 vAddr.add(data.substring(pre_pos, pos));
					 data=data.substring(pos+1);
				 }
				 else {
					 if(!data.isEmpty()) vAddr.add(data);
					 break;
					 }
			 }
			 
			 synchronized(svr_addr){
				 svr_addr=vAddr; 
			 }
		 }
		 //return "";
	 }
	 public String SendFile(String ac,String file_name,int dati_type,int timeout,int pri,String extra_str){
		 GetSvrAddr();
		 Vector<String> vAddr=new Vector<String>();
		 //ȡ·
		 //Ĭϵ2ַ
		 vAddr.add("http://dt1.91yzm.com:8080");
		 vAddr.add("http://dt2.91yzm.com:8080");
		 synchronized(svr_addr){
			 if(!svr_addr.isEmpty()) vAddr=svr_addr; 
		 }
		 //⣬ɹļɷ
		 for(int i=0;i<vAddr.size();i++){
			 try {
				 	BOUNDARY= "----------------"+System.currentTimeMillis();
				 	URL url;
				 	url = new URL(vAddr.get(i)+"/uploadpic.php");
				 	conn = (HttpURLConnection) url.openConnection();
				 	conn.setConnectTimeout(2000);//óʱʱ
				 	conn.setReadTimeout(10000);
				 	conn.setDoOutput(true);
				 	conn.setUseCaches(false); 
				 	conn.setRequestProperty("User-Agent", "91yzm_java_http");
				 	conn.setRequestMethod("POST");
				 	conn.setRequestProperty("Content-Type", "multipart/form-data; boundary="+BOUNDARY);
				 	InputStream is = new FileInputStream(file_name);
		        	StringBuffer postData = new StringBuffer(EXTRA+BOUNDARY+CRLF);
		        	postData.append(CONTENT_DISPOSITION+QUOTE+"pic"+QUOTE+FILE_NAME+QUOTE+file_name+QUOTE+CRLF);
		        	postData.append("Content-Type: image/jpeg"+CRLF+CRLF);
		            
		            OutputStream os = conn.getOutputStream();
		            byte headerData [] =postData.toString().getBytes();
		            os.write(headerData);
		                
		            byte[] fileData = getBytes(is);
		            os.write(fileData);
		            os.write((EXTRA+BOUNDARY+CRLF).getBytes());
		            //
		            String param = genernateRequestParam("acc_str",ac)+genernateRequestParam("dati_type",Integer.toString(dati_type))+genernateRequestParam("timeout",Integer.toString(timeout))+genernateRequestParam("pri",Integer.toString(pri))+genernateRequestParam("extra_str",extra_str);
		            if(!str_author.isEmpty()) param+=genernateRequestParam("zz",str_author);
		            os.write(param.getBytes());
		             
		            String endS = EXTRA+BOUNDARY+EXTRA+CRLF;
		            os.write(endS.getBytes());
		            os.flush();
		            os.close();
		            String id="";
		            InputStreamReader ir=new InputStreamReader(conn.getInputStream());
		            BufferedReader br = new BufferedReader(ir);
		            id=br.readLine();
		            conn.disconnect();
		            if(id!=null&&!id.isEmpty()&&id.charAt(0)!='#'){
		            	dt_info di=new dt_info();
		            	di.str_svr=vAddr.get(i);
		            	di.time=System.currentTimeMillis();
			            synchronized(id_addr){
			            	id_addr.put(id, di); 
			   			}
		             }
		             return id;
		                
		         } catch (FileNotFoundException e) {
	                 return "#ȡļʧ";
		         } catch (MalformedURLException e) {
	                 e.printStackTrace();
		         } catch (IOException e) {
	                 e.printStackTrace();
		         }catch (Exception e) {
	                 e.printStackTrace();
		         }
		 }
		 
	         return "#ʧ";
	 }
	 public String SendGet(String urlname,String param) throws Exception{
		 try{
			 String urlNameString = urlname;
			 if(param!=null && !param.isEmpty())urlNameString=urlNameString+ "?" + param;
	         URL realUrl = new URL(urlNameString);
			 conn = (HttpURLConnection) realUrl.openConnection();
			 conn.setConnectTimeout(2000);//óʱʱ
			 conn.setReadTimeout(10000);
			 conn.setDoOutput(true);
			 conn.setUseCaches(false); 
			 conn.setRequestProperty("User-Agent", "91yzm_java_http");
			 InputStreamReader ir=new InputStreamReader(conn.getInputStream());
         	 BufferedReader br = new BufferedReader(ir);
         	 String answer="";
         	 answer=br.readLine();
         	 conn.disconnect();
         	
         	 return answer;
         	//return br.readLine();
		 } catch (MalformedURLException e) {
             e.printStackTrace();
             throw e;
		 } catch (IOException e) {
             e.printStackTrace();
             throw e;
		 } 
	 }
	 public String GetAnswer(String id) {
		 //ɾ5ǰĿϢռڴ
		 long curTime=System.currentTimeMillis();
		 synchronized(id_addr){
			 Iterator<String> iter = id_addr.keySet().iterator();
			 while (iter.hasNext()) {
			     String key = iter.next();
			     if(curTime-id_addr.get(key).time>5*60*1000) iter.remove();
			 }
		 }
		 
		 if(id.length()>0&&id.charAt(0)=='#') return id;
		 String str_svr="";
         synchronized(id_addr){
        	 dt_info dii=id_addr.get(id);
        	 if(dii!=null)str_svr=dii.str_svr; 
        	 
		 }
         String answer="";
         if(str_svr!=null&&!str_svr.isEmpty()){
        	 try{
        		 answer=SendGet(str_svr+"/query.php","sid="+id);
        		 if(answer!=null&&!answer.isEmpty()) id_addr.remove(id);//ȡ𰸺ʹmapɾϢڴռ̫
        		 return answer;
        	 } catch(Exception e){
        	 }
         }
         //·޷ȡ𰸣·ȡ
    	 id_addr.remove(id);
    	 Vector<String> vAddr=new Vector<String>();
		 vAddr.add("http://dt1.91yzm.com:8080");
		 vAddr.add("http://dt2.91yzm.com:8080");
		 synchronized(svr_addr){
			 if(!svr_addr.isEmpty()) vAddr=svr_addr; 
		 }
		 for(int i=0;i<vAddr.size();i++){
			 if(str_svr==vAddr.get(i)) continue;
			 try{
        		 answer=SendGet(vAddr.get(i)+"/query.php","sid="+id);
        		 return answer;
        	 } catch(Exception e){
        	 }
		 }
		 return answer;		 
	 }
	 //ļתֽ  
	    private byte[] getBytes(InputStream in) throws Exception {  
	        ByteArrayOutputStream out = new ByteArrayOutputStream();  
	        byte[] b = new byte[1024];  
	        int n;  
	        while ((n = in.read(b)) != -1) {  
	            out.write(b, 0, n);  
	        }  
	        in.close();  
	        return out.toByteArray();  
	    } 
	    //ģⷢͱ
	    private String genernateRequestParam(String name,String value){
	     StringBuffer param = new StringBuffer(EXTRA+BOUNDARY+CRLF);
	     param.append(CONTENT_DISPOSITION+QUOTE+name+QUOTE+CRLF);
	     param.append(CRLF);
	     param.append(value+CRLF);
	     return param.toString();
	    }
	    
	 public static void main(String[] args){
		 java_http.SetAuthor("ʺ");//ʺ
		 java_http jh = new java_http("");
		 
		 String id=jh.SendFile("봮","1.jpg",21999,30,1,"");
		 String answer="";
		 while(answer==null||answer.length()==0){
		   try {
	            Thread.sleep(1000);
	        } catch (InterruptedException e) {
	            e.printStackTrace(); 
	        }
		   jh =new java_http("");
		   answer=jh.GetAnswer(id);	   
		 }
		 System.out.printf(answer);	  
	 	}
	}
